=encoding utf8

=head1 NAME

Mail::Message::Convert::MimeEntity - translate Mail::Message to MIME::Entity vv

=head1 INHERITANCE

 Mail::Message::Convert::MimeEntity
   is a Mail::Message::Convert
   is a Mail::Reporter

=head1 SYNOPSIS

  use Mail::Message::Convert::MimeEntity;
  my $convert = Mail::Message::Convert::MimeEntity->new;

  my Mail::Message $msg    = Mail::Message->new;
  my MIME::Entity  $entity = $convert->export($msg);

  my MIME::Entity  $entity = MIME::Entity->new;
  my Mail::Message $msg    = $convert->from($entity);

  use Mail::Box::Manager;
  my $mgr     = Mail::Box::Manager->new;
  my $folder  = $mgr->open(folder => 'Outbox');
  $folder->addMessage($entity);

=head1 DESCRIPTION

The MIME::Entity extends L<Mail::Internet|Mail::Internet> message with multiparts
and more methods.  The L<Mail::Message|Mail::Message> objects are more flexible
in how the message parts are stored, and uses separate header and body
objects.

Extends L<"DESCRIPTION" in Mail::Message::Convert|Mail::Message::Convert/"DESCRIPTION">.

=head1 METHODS

Extends L<"METHODS" in Mail::Message::Convert|Mail::Message::Convert/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Message::Convert|Mail::Message::Convert/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Message::Convert/"METHODS">

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Message::Convert|Mail::Message::Convert/"Attributes">.

=head2 Converting

Extends L<"Converting" in Mail::Message::Convert|Mail::Message::Convert/"Converting">.

=over 4

=item $obj-E<gt>B<export>( $message, [$parser] )

Returns a new MIME::Entity message object based on the
information from the C<$message>, which is a L<Mail::Message|Mail::Message> object.

You may want to supply your own C<$parser>, which is a MIME::Parser
object, to change the parser flags.  Without a C<$parser> object, one
is created for you, with all the default settings.

If C<undef> is passed, in place of a C<$message>, then an empty list is
returned.  When the parsing failes, then MIME::Parser throws an
exception.

» example: 

  my $convert = Mail::Message::Convert::MimeEntity->new;
  my Mail::Message $msg  = Mail::Message->new;
  my MIME::Entity  $copy = $convert->export($msg);

=item $obj-E<gt>B<from>($mime_object)

Returns a new L<Mail::Message|Mail::Message> object based on the information from
the specified MIME::Entity.  If the conversion fails, the C<undef>
is returned.  If C<undef> is passed in place of an OBJECT, then an
empty list is returned.

» example: 

  my $convert = Mail::Message::Convert::MimeEntity->new;
  my MIME::Entity  $msg  = MIME::Entity->new;
  my Mail::Message $copy = $convert->from($msg);

=item $obj-E<gt>B<selectedFields>($head)

Inherited, see L<Mail::Message::Convert/"Converting">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Message::Convert|Mail::Message::Convert/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Message::Convert|Mail::Message::Convert/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DIAGNOSTICS

=over 4

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Error: converting from MIME::Entity but got a $class.

Cast by C<from()>

=item Error: export message must be a Mail::Message object, but is $what.

Cast by C<export()>

=back

=head1 SEE ALSO

This module is part of Mail-Message version 4.05,
built on April 10, 2026. Website: F<http://perl.overmeer.net/mailbox/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

